id: {{ entity_type }}_{{ bundle_name }}_relations
label: Migrate {{ bundle_label }} relations from XML dump
migration_group: ismi_migration_relations
status: true

destination:
  plugin: entity:{{ entity_type }}
  bundle: {{ bundle_name }}
  translations: false

source:
  plugin: url
  urls:
    - "{{ source_xml_base }}-{{ bundle_name }}.xml"

  track_changes: false
  data_fetcher_plugin: file
  data_parser_plugin: xml
  item_selector: '/openmind-data/relations/relation'
  fields:
    -
      name: label
      label: default value/label
      selector: 'text()'
    -
      name: ismi_id
      label: Unique content ID
      selector: '@id'
    -
      name: object_class
      label: object type
      selector: '@object-class'
    -
      name: source_id
      label: source id
      selector: '@source-id'
    -
      name: target_id
      label: target id
      selector: '@target-id'
    -
      name: source_class
      label: source type
      selector: '@source-class'
    -
      name: target_class
      label: target type
      selector: '@target-class'

  ids:
     ismi_id:
       type: string

process:
  _skip:
    -
      # match source type
      plugin: skip_on_value
      source: source_class
      not_equals: true
      value: '{{ xml_original_type }}'
      method: row
      
  type:
    -
      plugin: default_value
      default_value: {{ bundle_name }}

  nid:
    -
      # lookup source type and ismi_id 
      plugin: entity_lookup
      value_key: {{ bundle_name }}_ismi_id
      bundle_key: type
      bundle: {{ bundle_name }}
      entity_type: {{ entity_type }}
      ignore_case: true
      source: source_id
    -
      plugin: skip_on_empty
      method: row


{% for field_name, field_info in field_info_xmls %}
{% if field_info.type == 'entity_reference' %}
  {{ field_info.drupal_field_name }}:
    -
      # match relation name
      plugin: skip_on_value
      source: object_class
      not_equals: true
      value: '{{ field_info.xml_attribute }}'
      method: process
    -
      # lookup target type and ismi_id
      plugin: entity_lookup
      value_key: {{ field_info.target }}_ismi_id
      bundle_key: type
      bundle: {{ field_info.target }}
      entity_type: {{ entity_type }}
      ignore_case: true
      source: target_id

{% endif %}
{% endfor %}

#migration_dependencies:
#  required:
#{% for field_name, field_info in field_info_xmls if field_info.target %}
#    - {{ entity_type }}_{{ field_info.target }}
#{% endfor %}